# $Revision: 1.71 $, $Date: 2010/09/16 06:48:41 $
# TODO
# - descriptions
#
# Conditional build:
%bcond_without	dist_kernel	# without distribution kernel
%bcond_without	kernel		# don't build kernel modules
%bcond_without	userspace	# # don't build userspace tools
%bcond_with	verbose		# verbose build (V=1)

%if %{without kernel}
%undefine	with_dist_kernel
%endif
%if "%{_alt_kernel}" != "%{nil}"
%undefine	with_userspace
%endif
%if %{without userspace}
# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0
%endif

%define		rel	11
Summary:	Extensible packet filtering system && extensible NAT system
Summary(pl.UTF-8):	System filtrowania pakietów oraz system translacji adresów (NAT)
Summary(pt_BR.UTF-8):	Ferramenta para controlar a filtragem de pacotes no kernel-2.6.x
Summary(ru.UTF-8):	Утилиты для управления пакетными фильтрами ядра Linux
Summary(uk.UTF-8):	Утиліти для керування пакетними фільтрами ядра Linux
Summary(zh_CN.UTF-8):	Linux内核包过滤管理工具
Name:		xtables-addons
Version:	1.28
Release:	%{rel}
License:	GPL
Group:		Networking/Admin
Source0:	http://downloads.sourceforge.net/xtables-addons/%{name}-%{version}.tar.xz
# Source0-md5:	b94fe23370a1294b985e9a06a0f9d129
URL:		http://xtables-addons.sourceforge.net/
Patch0:		kernelrelease.patch
Patch1:		%{name}-pre2.6.35-checkentry.patch
BuildRequires:	autoconf
BuildRequires:	automake >= 1.10.2
BuildRequires:	iptables-devel >= 1.4.3
%{?with_dist_kernel:BuildRequires:	kernel%{_alt_kernel}-module-build >= 3:2.6.25}
BuildRequires:	libtool
BuildRequires:	pkgconfig >= 0.9.0
BuildRequires:	rpmbuild(macros) >= 1.379
BuildRequires:	tar >= 1.22
BuildRequires:	xz
Requires:	iptables >= 1.4.3
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# use macro, so adapter won't try to wrap
%define		kpackage	kernel%{_alt_kernel}-net-xtables-addons = %{version}-%{rel}@%{_kernel_ver_str}

%description
An extensible NAT system, and an extensible packet filtering system.
Replacement of ipchains in 2.6 and higher kernels.

You should have %{kpackage} installed for the tools to work.

%description -l pl.UTF-8
Wydajny system translacji adresów (NAT) oraz system filtrowania
pakietów. Zamiennik ipchains w jądrach 2.6 i nowszych.

%description -l pt_BR.UTF-8
Esta é a ferramenta que controla o código de filtragem de pacotes do
kernel 2.6, obsoletando ipchains. Com esta ferramenta você pode
configurar filtros de pacotes, NAT, mascaramento (masquerading),
regras dinâmicas (stateful inspection), etc.

%description -l ru.UTF-8
xtables-addons управляют кодом фильтрации сетевых пакетов в ядре
Linux. Они позволяют вам устанавливать межсетевые экраны (firewalls) и
IP маскарадинг, и т.п.

%description -l uk.UTF-8
xtables-addons управляють кодом фільтрації пакетів мережі в ядрі
Linux. Вони дозволяють вам встановлювати міжмережеві екрани
(firewalls) та IP маскарадинг, тощо.

%package -n kernel%{_alt_kernel}-net-xtables-addons
Summary:	Kernel modules for xtables addons
Summary(pl.UTF-8):	Moudły jądra dla xtables addons
Release:	%{rel}@%{_kernel_ver_str}
Group:		Base/Kernel
# VERSION only dependency is intentional, for allowing multiple kernel pkgs and
# single userspace package installs.
Requires:	%{name} = %{version}
Suggests:	xtables-geoip
Conflicts:	xtables-geoip < 20090901-2
%{?with_dist_kernel:%requires_releq_kernel}
Requires(post,postun):	/sbin/depmod

%description -n kernel%{_alt_kernel}-net-xtables-addons
Kernel modules for xtables addons.

%description -n kernel%{_alt_kernel}-net-xtables-addons -l pl.UTF-8
Moduły jądra dla xtables addons.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%{__sed} -i -e 's#build_ipset=m#build_ipset=n#' mconfig

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__automake}
%configure \
	--with-kbuild=no

%if %{with kernel}
srcdir=${PWD:-$(pwd)}
%build_kernel_modules V=1 XA_ABSTOPSRCDIR=$srcdir -C extensions -m compat_xtables
%endif

%if %{with userspace}
%{__make}
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/modprobe.d,/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter,%{_mandir}/man8}

%if %{with kernel}
cd extensions
install iptable_rawpost.ko $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter
%install_kernel_modules -m compat_xtables -d kernel/net/netfilter
install -p {ACCOUNT/,pknock/,}xt_*.ko $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}/kernel/net/netfilter
cd ..
%endif

%if %{with userspace}
%{__make} -C extensions install \
	DESTDIR=$RPM_BUILD_ROOT

rm -f $RPM_BUILD_ROOT%{_libdir}/libxt_ACCOUNT_cl.{la,so}
# provided by iptables
rm -f $RPM_BUILD_ROOT%{_libdir}/xtables/libxt_TEE.so

cp -a xtables-addons.8 $RPM_BUILD_ROOT%{_mandir}/man8
%endif

cat <<'EOF' > $RPM_BUILD_ROOT/etc/modprobe.d/xt_sysrq.conf
# Set password at modprobe time. if this file is secure if properly guarded,
# i.e only readable by root.
#options xt_SYSRQ password=cookies

# The hash algorithm can also be specified as a module option, for example, to use SHA-256 instead of the default SHA-1:
#options xt_SYSRQ hash=sha256
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%post -n kernel%{_alt_kernel}-net-xtables-addons
%depmod %{_kernel_ver}

%postun -n kernel%{_alt_kernel}-net-xtables-addons
%depmod %{_kernel_ver}

%if %{with userspace}
%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/iptaccount
%attr(755,root,root) %{_libdir}/xtables/libxt_*.so
%attr(755,root,root) %{_libdir}/libxt_ACCOUNT_cl.so.*
%{_mandir}/man8/xtables-addons.8*
%endif

%if %{with kernel}
%files -n kernel%{_alt_kernel}-net-xtables-addons
%defattr(644,root,root,755)
%config(noreplace) %verify(not md5 mtime size) /etc/modprobe.d/xt_sysrq.conf
/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter/iptable_rawpost.ko.gz
/lib/modules/%{_kernel_ver}/kernel/net/netfilter/compat_xtables.ko.gz
/lib/modules/%{_kernel_ver}/kernel/net/netfilter/xt_*.ko.gz
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: xtables-addons.spec,v $
Revision 1.71  2010/09/16 06:48:41  arekm
- release 11

Revision 1.70  2010/09/01 16:14:02  gotar
- unbroken on pre2.6.23 kernels (upstream fix: http://xtables-addons.git.sf.net/git/gitweb.cgi?p=xtables-addons/xtables-addons;a=commitdiff;h=fb2eea69afa1717b4e0d8edb471c0aa36b8603bb), rel. 10

Revision 1.69  2010/09/01 08:00:56  gotar
- fine-grained automake BR (pkglibexecdir)

Revision 1.68  2010/09/01 07:36:28  gotar
- added .checkentry return value patch for pre-2.6.35 kernels, rel. 9

Revision 1.67  2010/08/29 16:39:59  gotar
- kernel: package rawpost table, ACCOUNT target and pknock match, rel. 8

Revision 1.66  2010/08/29 16:01:53  gotar
- BR: tar >= 1.22, xz (.tar.xz Source0), strict am and pkgconfig versions
- fixed --without userspace build (/etc/modprobe.d/xt_sysrq.conf), cleanup

Revision 1.65  2010/08/29 12:26:43  arekm
- rel 7; drop libxt_TEE.so (provided by iptables)

Revision 1.64  2010/08/29 12:05:15  gotar
- fixed kpackage description

Revision 1.63  2010/08/27 08:35:51  arekm
- release 6

Revision 1.62  2010/08/22 05:47:29  arekm
- release 5

Revision 1.61  2010/08/15 16:42:40  arekm
- release 4

Revision 1.60  2010/08/11 09:28:21  arekm
- release 3

Revision 1.59  2010/08/09 07:57:37  arekm
- release 2

Revision 1.58  2010/07/25 01:05:18  glen
- up to 1.28

Revision 1.57  2010/06/08 07:05:14  glen
- geoipt problem solved with suggests line; rel 2

Revision 1.56  2010/06/08 07:02:45  glen
- uptaccount todo is done

Revision 1.55  2010/06/07 20:57:11  arekm
- up to 1.27

Revision 1.54  2010/05/28 18:38:33  arekm
- release 2

Revision 1.53  2010/05/21 10:04:37  glen
- release 1

Revision 1.52  2010/05/02 17:03:38  glen
- up to 1.26

Revision 1.51  2010/04/27 07:22:05  glen
- up to 1.25
- GeoIP DB moved to /usr/share/xt_geoip

Revision 1.50  2010/03/17 07:29:16  arekm
- release 11

Revision 1.49  2010/03/16 06:14:43  arekm
- release 10

Revision 1.48  2010/02/15 09:41:21  arekm
- release 9

Revision 1.47  2010/01/14 16:20:42  glen
- allow preparing kernel for reboot (poldek -i for kernel pkg, poldek -u for userspace), without removing currently running package modules

Revision 1.46  2010/01/08 18:10:48  arekm
- release 8

Revision 1.45  2010/01/07 11:13:30  pawelz
- pl for kernel package

Revision 1.44  2010/01/07 11:04:13  glen
- description of kernel package
- small note in userspace tool for kernel modules or you get error "iptables: No chain/target/match by that name."

Revision 1.43  2009/12/19 11:00:56  arekm
- release 7

Revision 1.42  2009/12/16 18:00:48  arekm
- release 6

Revision 1.41  2009/12/12 20:03:27  arekm
- release 5

Revision 1.40  2009/11/22 20:58:32  arekm
- release 4

Revision 1.39  2009/11/12 09:38:21  arekm
- release 3

Revision 1.38  2009/11/02 10:31:40  gotar
- new ACCOUNT target and psd match, get rid of verbose nonsense listings

Revision 1.37  2009/11/02 10:22:06  gotar
- upgraded to 1.18; 2.6.31 support

Revision 1.36  2009/11/01 16:39:34  arekm
- release 4

Revision 1.35  2009/10/21 19:06:15  arekm
- release 3

Revision 1.34  2009/08/01 20:11:04  arekm
- release 2

Revision 1.33  2009/06/16 19:37:48  paszczus
- updated to 1.17

Revision 1.32  2009/06/03 00:24:21  zbyniu
- kill stupid kernel version checks (kernelrelease.patch)
- works now; rel 2

Revision 1.31  2009/05/01 13:17:42  paszczus
- updated to 1.15

Revision 1.30  2009/04/01 08:39:33  paszczus
- updated to 1.14, new modules added.

Revision 1.29  2009/03/24 09:33:47  gotar
- initial upgrade to 1.13

Revision 1.28  2009/03/23 15:57:05  gotar
- separated kernel modules package (one can have multiple kernels with
  single common tools, or no dist_kernel at all), release 2,
- some template-kernel-module.spec merges.

Revision 1.27  2009/03/20 22:35:33  areq
- 1.12
- new URL
- rename xt_portscan to xt_lscan
- drop ipset (use ipset.spec)

Revision 1.26  2009/02/18 19:44:32  paszczus
- updated to 1.10
- added new modules for libxt
- added (but commented) libipset (is it place for them?)
- not packaged /sbin/ipset
- rel 0.1

Revision 1.25  2009/02/17 23:04:44  arekm
- release 12

Revision 1.24  2009/02/10 07:28:07  arekm
- release 11

Revision 1.23  2009/02/07 16:57:27  arekm
- release 10

Revision 1.22  2009/01/25 12:56:00  arekm
- release 9

Revision 1.21  2009/01/19 12:30:43  arekm
- release 8

Revision 1.20  2009/01/15 12:54:26  arekm
- release 7

Revision 1.19  2009/01/10 22:37:46  arekm
- release 6

Revision 1.18  2008/12/19 06:31:25  arekm
- release 5

Revision 1.17  2008/12/14 11:43:24  arekm
- release 4

Revision 1.16  2008/12/06 09:00:40  arekm
- release 3

Revision 1.15  2008/11/21 16:16:09  arekm
- release 2

Revision 1.14  2008/11/20 10:49:44  paszczus
- updated to 1.6

Revision 1.13  2008/11/08 09:27:18  arekm
- release 4

Revision 1.12  2008/11/04 07:42:08  arekm
- release 3

Revision 1.11  2008/10/27 10:01:52  pluto
- dont build an old ipset stuff, uset ipset.spec instead, release 2.

Revision 1.10  2008/09/27 23:21:25  charles
- added URL and updated Source0
- lt/ac/am (with BRs)
- fixed post{un}; rel. 1

Revision 1.9  2008/09/21 18:34:28  pluto
- O: ipset-init.

Revision 1.8  2008/09/12 13:47:30  paszczus
- added xtables-addons-help.patch

Revision 1.7  2008/09/12 09:26:14  pluto
- updated to 1.5.7. it includes ipset v2.3.2a now.

Revision 1.6  2008-05-23 11:52:38  zbyniu
- geoip-dbpath.patch added; R: iptables >= 1.4.1; works

Revision 1.5  2008-05-22 09:41:12  zbyniu
- up to 1.5.4.1, now builds with iptables-1.4.1
- depend on _kernel_ver_str (kernel modules)
- needs tests and cleanups

Revision 1.4  2008-04-09 23:51:45  zbyniu
- up to 1.5.4
- patch to make possible only userspace modules build/install
- kernel/userspace bconds

Revision 1.3  2008-03-09 23:07:32  zbyniu
- now builds, still needs more work; TODO added

Revision 1.2  2008-03-09 22:05:12  arekm
- update paths

Revision 1.1  2008-03-09 21:56:56  arekm
- initial
